<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                template="./../plantilla-principal.xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <f:metadata>
            <f:event type="preRenderView" listener="#{sessionManBean.modulosFuncionalidad(13)}"></f:event>
        </f:metadata>
        <style>
            #btn-elim{
                display: none;
            }
            #form-datos\:btn-guardar{
                display: none;
            }
        </style>
        <h2 class="ui header">Zonas</h2>
        <div class="ui secondary menu">
            <div class="ui fitted item">
                <div id="btn-nuevo" class="ui green button">
                    <i class="file icon" />
                    Limpiar
                </div>
            </div>
            <div class="ui fitted item">
                <div jsf:rendered="#{sessionManBean.permisosAsignados(34)}" id="btn-elim" class="ui red button" rendered="#{sessionManBean.permisosAsignados(34)}">
                    <i class="trash icon" />
                    Eliminar
                </div>
            </div>
        </div>
        <div class="ui grid">
            <div class="eleven wide column">
                <h:form id="form-filtro">
                    <div class="ui fluid icon input">
                        <input id="txf-buscar" type="text" placeholder="Buscar" jsf:value="#{zonasManBean.txtBusqueda}" />
                        <i id="icono-busqueda" class="search icon" />
                    </div>
                    <h:commandLink id="cl-buscar" style="display: none" action="#{zonasManBean.buscarZona()}">
                        <f:ajax execute="@form" render="form-tabla" onevent="function(data){ajaxBusqueda(data)}" />
                    </h:commandLink>
                </h:form>
                <h:form id="form-tabla">
                    <table jsf:id="tabla-datos" class="ui selectable celled table">
                        <thead>
                            <tr><th class="collapsing">
                                    <div onclick="seleccionarTodo()" class="ui fitted checkbox">
                                        <input type="checkbox" id="chk-selec-todo"/>
                                        <label/>
                                    </div>
                                </th>
                                <th>ID</th><th>Nombre</th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{zonasManBean.lstZonas}" var="zona" varStatus="stZona">
                                <tr id="rw-#{zona.idzona}">
                                    <td>
                                        <div onclick="selecFila(#{zona.idzona})" class="ui fitted checkbox">
                                            <input type="checkbox" id="chk-sl-#{zona.idzona}"/>
                                            <label/>
                                        </div>
                                    </td>
                                    <td id="col-id-#{zona.idzona}" onclick="selecFila(#{zona.idzona})">#{zona.idzona}</td>
                                    <td id="col-nombre-#{zona.idzona}" onclick="selecFila(#{zona.idzona})">#{zona.nombre}</td>
                                </tr>

                            </ui:repeat>
                        </tbody>
                        <div id="dim-tabla" class="ui inverted dimmer"/>
                    </table>
                </h:form>
            </div>
            <div class="five wide column">
                <h:form id="form-datos">
                    <div class="ui form">
                        <div class="field">
                            <label>ID</label>
                            <input id="txf-id" disabled="true" placeholder="ID" type="number" jsf:value="#{zonasManBean.zonaVar.idzona}"/>
                            <h:inputHidden value="#{zonasManBean.zonaVar.idzona}" id="idzona-hidden" />
                        </div>
                        <div class="field">
                            <label>Nombre</label>
                            <input id="txf-nombre" placeholder="Nombre" type="text" jsf:value="#{zonasManBean.zonaVar.nombre}"/>
                        </div>
                        <div class="field">
                            <h:commandLink rendered="#{sessionManBean.permisosAsignados(35)}" id="btn-guardar" class="ui teal button" action="#{zonasManBean.modificarZona()}">
                                <i class="save icon" />
                                Guardar
                                <f:ajax id="ajx-guardar" execute="@form" render="form-tabla lbl-msg-status" onevent="function(data){ajaxModificar(data);}" />
                            </h:commandLink>
                            <h:commandLink rendered="#{sessionManBean.permisosAsignados(23)}" id="btn-agregar" class="ui primary button" action="#{zonasManBean.agregarZona()}">
                                <i class="circle add icon"/>
                                Agregar
                                <f:ajax onevent="function(data){ajaxAgregar(data)}" execute="@form" render="form-tabla lbl-msg-status" />
                            </h:commandLink>
                        </div>
                    </div>


                    <div id="msg-status" class="ui hidden info message">
                        <i class="close icon"></i>
                        <div id="titulo-msg" class="header">
                            Agregar Zona
                        </div>
                        <h:outputText id="lbl-msg-status" value="#{zonasManBean.msg}" />
                    </div>
                </h:form>
            </div>
        </div>
            <h:form rendered="#{sessionManBean.permisosAsignados(34)?'':'hidden'}" id="dlg-conf-elim" class="ui basic modal">
            <input name="selbar" id="selbar" type="hidden" jsf:value="#{zonasManBean.selElimIDJSON}"/>
            <div class="ui icon header">
                <i class="trash icon"></i>
                Eliminar zonas
            </div>
            <div class="centered content">
                <p>¿Desea eliminar los elementos seleccionados?</p>
            </div>
            <div class="actions">
                <button jsf:action="#{zonasManBean.eliminarZonas()}" class="ui green ok inverted button">
                    <i class="checkmark icon"></i>
                    Sí
                    <f:ajax execute="@form" onevent="generarDatosSeleccion()" render="form-tabla"/>
                </button>
                <div class="ui red basic cancel inverted button">
                    <i class="remove icon"></i>
                    No
                </div>
            </div>
        </h:form>
        <script>
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });

            $('#btn-elim').click(function () {
                $('#dlg-conf-elim').modal('show');
            });

            function selecFila(id) {
                var nombFila = "#rw-" + id;
                var nombCheck = "#chk-sl-" + id;
                if ($(nombFila).hasClass('active')) {
                    $(nombFila).removeClass('active');
                    $(nombCheck).prop('checked', false);
                } else {
                    $(nombFila).addClass('active');
                    $(nombCheck).prop('checked', true);
                }
                ocultarBtnElim();
                comprobarSeleccionTodo();
                modoModificar();
                var seleccionados = $('tbody :checkbox:checked').length;
                if (seleccionados === 1) {
                    cargarDatos(id);
                } else {
                    limpiarFormulario();
                }
            }

            function limpiarFormulario() {
                $('#form-datos\\:idzona-hidden').val('');
                $('#txf-nombre').val('');
                $('#txf-id').val('');
            }

            function cargarDatos(id) {
                var colId = "#col-id-" + id;
                var colNombre = "#col-nombre-" + id;
                $('#txf-nombre').val($(colNombre).html());
                $('#txf-id').val($(colId).html());
                $('#form-datos\\:idzona-hidden').val($(colId).html());

            }

            function seleccionarTodo() {
                if ($('#chk-selec-todo').prop('checked')) {
                    $('tbody tr').addClass('active');
                    $('tbody :checkbox').prop('checked', true);
                } else {
                    $('tbody tr').removeClass('active');
                    $('tbody :checkbox').prop('checked', false);
                }
                ocultarBtnElim();
                //comprobarSeleccionTodo();
                modoModificar();
            }

            function ocultarBtnElim() {
                var seleccionados = $('tbody :checkbox:checked').length;
                if (seleccionados > 0) {
                    $('#btn-elim').show();
                } else {
                    $('#btn-elim').hide();
                }
            }

            function modoModificar() {
                var seleccionados = $('tbody :checkbox:checked').length;
                if (seleccionados === 1) {
                    $('#form-datos\\:btn-guardar').css('display', 'inline-block');
                    $('#form-datos\\:btn-agregar').css('display', 'none');
                } else {
                    $('#form-datos\\:btn-guardar').css('display', 'none');
                    $('#form-datos\\:btn-agregar').css('display', 'inline-block');
                }
            }

            function comprobarSeleccionTodo() {
                var seleccionados = $('tbody :checkbox:checked').length;
                var cantFilas = $('tbody tr').length;
                if (seleccionados === cantFilas) {
                    $('#chk-selec-todo').prop('checked', true);
                } else {
                    $('#chk-selec-todo').prop('checked', false);
                }
            }

            function generarDatosSeleccion() {
                var idSeleccionados = [];
                $("tbody tr [id^='col-id']").each(function (index, value) {
                    var id = parseInt($(this).html());
                    if ($('#chk-sl-' + id).prop('checked')) {
                        idSeleccionados.push(id);
                    }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar').val(jsonselect);
                $('#div-btn-elim').hide();
            }

            function ajaxModificar(data) {
//                console.log(data.status);
                $('#titulo-msg').html('Modificar Zona');
                if (data.status === 'begin') {
                    $('#form-datos\\:btn-guardar').addClass('disabled');
                    $('#form-datos\\:btn-guardar').addClass('loading');
                }
                if (data.status !== 'begin') {
                    $('#form-datos\\:btn-guardar').removeClass('disabled');
                    $('#form-datos\\:btn-guardar').removeClass('loading');
                    if ($('#msg-status').css('display') === 'none') {
                        $('#msg-status').transition('fade');
                    }
                }
                if(data.status==='error'){
                    console.log('Error al actualizar');
                }
            }

            function ajaxAgregar(data) {
                if (data.status === 'begin') {
                    $('#form-datos\\:btn-agregar').addClass('disabled');
                    $('#form-datos\\:btn-agregar').addClass('loading');
                }
                if (data.status !== 'begin') {
                    $('#form-datos\\:btn-agregar').removeClass('disabled');
                    $('#form-datos\\:btn-agregar').removeClass('loading');
                    if ($('#msg-status').css('display') === 'none') {
                        $('#msg-status').transition('fade');
                    }
                }
                if (data.status === 'success') {
                    $('#titulo-msg').html('Agregar Zona');
                    if ($('#msg-status').css('display') === 'none') {
                        $('#msg-status').transition('fade');
                    }
                }
            }
            
            $('#btn-nuevo').click(function () {
                modoNuevo();
            });
            var timeOut=0;
            $('#txf-buscar').on('input', function (){
                clearTimeout(timeOut);
                timeOut=setTimeout(function() {
                    $('#form-filtro\\:cl-buscar').click();
                    modoNuevo();
                }, 500);
            });
            
            function modoNuevo(){
                limpiarFormulario();
                $('#form-datos\\:btn-guardar').css('display', 'none');
                $('#form-datos\\:btn-agregar').css('display', 'inline-block');
                $('tbody :checkbox:checked').prop('checked', false);
                $('tbody tr').removeClass('active');
                $('#chk-selec-todo').prop('checked', false);
                ocultarBtnElim();
            }
            
            function ajaxBusqueda(data){
                if(data.status==='begin'){
                    $('#dim-tabla').dimmer('show');
                    $('#icono-busqueda').removeClass('search');
                    $('#icono-busqueda').addClass('spinner');
                    $('#icono-busqueda').addClass('loading');
                }else{
                    $('#dim-tabla').dimmer('hide');
                    $('#icono-busqueda').addClass('search');
                    $('#icono-busqueda').removeClass('spinner');
                    $('#icono-busqueda').removeClass('loading');
                }
            }
        </script>
    </ui:define>

</ui:composition>
